/**
 * Copyright (c) 2023 Netmera Research.
 * @author Initial Code
 */

#import "FNEtmeraCouponObject.h"

@implementation FNetmeraCouponObject


+(NSArray<NSDictionary*>*) mapCouponObjects: (NSArray<NetmeraCouponObject *>*) couponObjects {
    NSMutableArray<NSDictionary*> *couponObjectList = [[NSMutableArray alloc]init];
    for (int i = 0; i < [couponObjects count]; i++) {
        [couponObjectList addObject: [self getCouponObjectMap:couponObjects[i]]];
    }
    return couponObjectList;
}

+(NSDictionary*) getCouponObjectMap:(NetmeraCouponObject*) couponObject {
    NSTimeInterval assignDateTs = [[couponObject assignDate] timeIntervalSince1970];
    NSTimeInterval expireDateTs = [[couponObject expireDate] timeIntervalSince1970];
    
    NSMutableDictionary *data = [NSMutableDictionary dictionary];
    [data setValue:[couponObject couponId] forKey:@"couponId"];
    [data setValue:[couponObject name] forKey:@"name"];
    [data setValue:[couponObject code] forKey:@"code"];
    [data setValue:[NSString stringWithFormat:@"%f", assignDateTs] forKey:@"assignDate"];
    [data setValue:[NSString stringWithFormat:@"%f", assignDateTs] forKey:@"expireDate"];

    return data;
}


@end

